Git 2.20
[git.git] / git-instaweb.sh
blobeec264e6303684c5886804361c630e1572c1fe09
1 #!/bin/sh
3 # Copyright (c) 2006 Eric Wong
6 PERL='@@PERL@@'
7 OPTIONS_KEEPDASHDASH=
8 OPTIONS_STUCKLONG=
9 OPTIONS_SPEC="\
10 git instaweb [options] (--start | --stop | --restart)
12 l,local only bind on 127.0.0.1
13 p,port= the port to bind to
14 d,httpd= the command to launch
15 b,browser= the browser to launch
16 m,module-path= the module path (only needed for apache2)
17 Action
18 stop stop the web server
19 start start the web server
20 restart restart the web server
23 SUBDIRECTORY_OK=Yes
24 . git-sh-setup
26 fqgitdir="$GIT_DIR"
27 local="$(git config --bool --get instaweb.local)"
28 httpd="$(git config --get instaweb.httpd)"
29 root="$(git config --get instaweb.gitwebdir)"
30 port=$(git config --get instaweb.port)
31 module_path="$(git config --get instaweb.modulepath)"
32 action="browse"
34 conf="$GIT_DIR/gitweb/httpd.conf"
36 # Defaults:
38 # if installed, it doesn't need further configuration (module_path)
39 test -z "$httpd" && httpd='lighttpd -f'
41 # Default is @@GITWEBDIR@@
42 test -z "$root" && root='@@GITWEBDIR@@'
44 # any untaken local port will do...
45 test -z "$port" && port=1234
47 resolve_full_httpd () {
48 case "$httpd" in
49 *apache2*|*lighttpd*|*httpd*)
50 # yes, *httpd* covers *lighttpd* above, but it is there for clarity
51 # ensure that the apache2/lighttpd command ends with "-f"
52 if ! echo "$httpd" | sane_grep -- '-f *$' >/dev/null 2>&1
53 then
54 httpd="$httpd -f"
57 *plackup*)
58 # server is started by running via generated gitweb.psgi in $fqgitdir/gitweb
59 full_httpd="$fqgitdir/gitweb/gitweb.psgi"
60 httpd_only="${httpd%% *}" # cut on first space
61 return
63 *webrick*)
64 # server is started by running via generated webrick.rb in
65 # $fqgitdir/gitweb
66 full_httpd="$fqgitdir/gitweb/webrick.rb"
67 httpd_only="${httpd%% *}" # cut on first space
68 return
70 esac
72 httpd_only="$(echo $httpd | cut -f1 -d' ')"
73 if case "$httpd_only" in /*) : ;; *) which $httpd_only >/dev/null 2>&1;; esac
74 then
75 full_httpd=$httpd
76 else
77 # many httpds are installed in /usr/sbin or /usr/local/sbin
78 # these days and those are not in most users $PATHs
79 # in addition, we may have generated a server script
80 # in $fqgitdir/gitweb.
81 for i in /usr/local/sbin /usr/sbin "$root" "$fqgitdir/gitweb"
83 if test -x "$i/$httpd_only"
84 then
85 full_httpd=$i/$httpd
86 return
88 done
90 echo >&2 "$httpd_only not found. Install $httpd_only or use" \
91 "--httpd to specify another httpd daemon."
92 exit 1
96 start_httpd () {
97 if test -f "$fqgitdir/pid"; then
98 say "Instance already running. Restarting..."
99 stop_httpd
102 # here $httpd should have a meaningful value
103 resolve_full_httpd
104 mkdir -p "$fqgitdir/gitweb/$httpd_only"
105 conf="$fqgitdir/gitweb/$httpd_only.conf"
107 # generate correct config file if it doesn't exist
108 test -f "$conf" || configure_httpd
109 test -f "$fqgitdir/gitweb/gitweb_config.perl" || gitweb_conf
111 # don't quote $full_httpd, there can be arguments to it (-f)
112 case "$httpd" in
113 *mongoose*|*plackup*)
114 #These servers don't have a daemon mode so we'll have to fork it
115 $full_httpd "$conf" &
116 #Save the pid before doing anything else (we'll print it later)
117 pid=$!
119 if test $? != 0; then
120 echo "Could not execute http daemon $httpd."
121 exit 1
124 cat > "$fqgitdir/pid" <<EOF
125 $pid
129 $full_httpd "$conf"
130 if test $? != 0; then
131 echo "Could not execute http daemon $httpd."
132 exit 1
135 esac
138 stop_httpd () {
139 test -f "$fqgitdir/pid" && kill $(cat "$fqgitdir/pid")
140 rm -f "$fqgitdir/pid"
143 httpd_is_ready () {
144 "$PERL" -MIO::Socket::INET -e "
145 local \$| = 1; # turn on autoflush
146 exit if (IO::Socket::INET->new('127.0.0.1:$port'));
147 print 'Waiting for \'$httpd\' to start ..';
148 do {
149 print '.';
150 sleep(1);
151 } until (IO::Socket::INET->new('127.0.0.1:$port'));
152 print qq! (done)\n!;
156 while test $# != 0
158 case "$1" in
159 --stop|stop)
160 action="stop"
162 --start|start)
163 action="start"
165 --restart|restart)
166 action="restart"
168 -l|--local)
169 local=true
171 -d|--httpd)
172 shift
173 httpd="$1"
175 -b|--browser)
176 shift
177 browser="$1"
179 -p|--port)
180 shift
181 port="$1"
183 -m|--module-path)
184 shift
185 module_path="$1"
190 usage
192 esac
193 shift
194 done
196 mkdir -p "$GIT_DIR/gitweb/tmp"
197 GIT_EXEC_PATH="$(git --exec-path)"
198 GIT_DIR="$fqgitdir"
199 GITWEB_CONFIG="$fqgitdir/gitweb/gitweb_config.perl"
200 export GIT_EXEC_PATH GIT_DIR GITWEB_CONFIG
202 webrick_conf () {
203 # webrick seems to have no way of passing arbitrary environment
204 # variables to the underlying CGI executable, so we wrap the
205 # actual gitweb.cgi using a shell script to force it
206 wrapper="$fqgitdir/gitweb/$httpd/wrapper.sh"
207 cat > "$wrapper" <<EOF
208 #!@SHELL_PATH@
209 # we use this shell script wrapper around the real gitweb.cgi since
210 # there appears to be no other way to pass arbitrary environment variables
211 # into the CGI process
212 GIT_EXEC_PATH=$GIT_EXEC_PATH GIT_DIR=$GIT_DIR GITWEB_CONFIG=$GITWEB_CONFIG
213 export GIT_EXEC_PATH GIT_DIR GITWEB_CONFIG
214 exec $root/gitweb.cgi
216 chmod +x "$wrapper"
218 # This assumes _ruby_ is in the user's $PATH. that's _one_
219 # portable way to run ruby, which could be installed anywhere, really.
220 # generate a standalone server script in $fqgitdir/gitweb.
221 cat >"$fqgitdir/gitweb/$httpd.rb" <<EOF
222 #!/usr/bin/env ruby
223 require 'webrick'
224 require 'logger'
225 options = {
226 :Port => $port,
227 :DocumentRoot => "$root",
228 :Logger => Logger.new('$fqgitdir/gitweb/error.log'),
229 :AccessLog => [
230 [ Logger.new('$fqgitdir/gitweb/access.log'),
231 WEBrick::AccessLog::COMBINED_LOG_FORMAT ]
233 :DirectoryIndex => ["gitweb.cgi"],
234 :CGIInterpreter => "$wrapper",
235 :StartCallback => lambda do
236 File.open("$fqgitdir/pid", "w") { |f| f.puts Process.pid }
237 end,
238 :ServerType => WEBrick::Daemon,
240 options[:BindAddress] = '127.0.0.1' if "$local" == "true"
241 server = WEBrick::HTTPServer.new(options)
242 ['INT', 'TERM'].each do |signal|
243 trap(signal) {server.shutdown}
245 server.start
247 chmod +x "$fqgitdir/gitweb/$httpd.rb"
248 # configuration is embedded in server script file, webrick.rb
249 rm -f "$conf"
252 lighttpd_conf () {
253 cat > "$conf" <<EOF
254 server.document-root = "$root"
255 server.port = $port
256 server.modules = ( "mod_setenv", "mod_cgi" )
257 server.indexfiles = ( "gitweb.cgi" )
258 server.pid-file = "$fqgitdir/pid"
259 server.errorlog = "$fqgitdir/gitweb/$httpd_only/error.log"
261 # to enable, add "mod_access", "mod_accesslog" to server.modules
262 # variable above and uncomment this
263 #accesslog.filename = "$fqgitdir/gitweb/$httpd_only/access.log"
265 setenv.add-environment = ( "PATH" => env.PATH, "GITWEB_CONFIG" => env.GITWEB_CONFIG )
267 cgi.assign = ( ".cgi" => "" )
269 # mimetype mapping
270 mimetype.assign = (
271 ".pdf" => "application/pdf",
272 ".sig" => "application/pgp-signature",
273 ".spl" => "application/futuresplash",
274 ".class" => "application/octet-stream",
275 ".ps" => "application/postscript",
276 ".torrent" => "application/x-bittorrent",
277 ".dvi" => "application/x-dvi",
278 ".gz" => "application/x-gzip",
279 ".pac" => "application/x-ns-proxy-autoconfig",
280 ".swf" => "application/x-shockwave-flash",
281 ".tar.gz" => "application/x-tgz",
282 ".tgz" => "application/x-tgz",
283 ".tar" => "application/x-tar",
284 ".zip" => "application/zip",
285 ".mp3" => "audio/mpeg",
286 ".m3u" => "audio/x-mpegurl",
287 ".wma" => "audio/x-ms-wma",
288 ".wax" => "audio/x-ms-wax",
289 ".ogg" => "application/ogg",
290 ".wav" => "audio/x-wav",
291 ".gif" => "image/gif",
292 ".jpg" => "image/jpeg",
293 ".jpeg" => "image/jpeg",
294 ".png" => "image/png",
295 ".xbm" => "image/x-xbitmap",
296 ".xpm" => "image/x-xpixmap",
297 ".xwd" => "image/x-xwindowdump",
298 ".css" => "text/css",
299 ".html" => "text/html",
300 ".htm" => "text/html",
301 ".js" => "text/javascript",
302 ".asc" => "text/plain",
303 ".c" => "text/plain",
304 ".cpp" => "text/plain",
305 ".log" => "text/plain",
306 ".conf" => "text/plain",
307 ".text" => "text/plain",
308 ".txt" => "text/plain",
309 ".dtd" => "text/xml",
310 ".xml" => "text/xml",
311 ".mpeg" => "video/mpeg",
312 ".mpg" => "video/mpeg",
313 ".mov" => "video/quicktime",
314 ".qt" => "video/quicktime",
315 ".avi" => "video/x-msvideo",
316 ".asf" => "video/x-ms-asf",
317 ".asx" => "video/x-ms-asf",
318 ".wmv" => "video/x-ms-wmv",
319 ".bz2" => "application/x-bzip",
320 ".tbz" => "application/x-bzip-compressed-tar",
321 ".tar.bz2" => "application/x-bzip-compressed-tar",
322 "" => "text/plain"
325 test x"$local" = xtrue && echo 'server.bind = "127.0.0.1"' >> "$conf"
328 apache2_conf () {
329 for candidate in \
330 /etc/httpd \
331 /usr/lib/apache2 \
332 /usr/lib/httpd ;
334 if test -d "$candidate/modules"
335 then
336 module_path="$candidate/modules"
337 break
339 done
340 bind=
341 test x"$local" = xtrue && bind='127.0.0.1:'
342 echo 'text/css css' > "$fqgitdir/mime.types"
343 cat > "$conf" <<EOF
344 ServerName "git-instaweb"
345 ServerRoot "$root"
346 DocumentRoot "$root"
347 ErrorLog "$fqgitdir/gitweb/$httpd_only/error.log"
348 CustomLog "$fqgitdir/gitweb/$httpd_only/access.log" combined
349 PidFile "$fqgitdir/pid"
350 Listen $bind$port
353 for mod in mpm_event mpm_prefork mpm_worker
355 if test -e $module_path/mod_${mod}.so
356 then
357 echo "LoadModule ${mod}_module " \
358 "$module_path/mod_${mod}.so" >> "$conf"
359 # only one mpm module permitted
360 break
362 done
363 for mod in mime dir env log_config authz_core unixd
365 if test -e $module_path/mod_${mod}.so
366 then
367 echo "LoadModule ${mod}_module " \
368 "$module_path/mod_${mod}.so" >> "$conf"
370 done
371 cat >> "$conf" <<EOF
372 TypesConfig "$fqgitdir/mime.types"
373 DirectoryIndex gitweb.cgi
376 # check to see if Dennis Stosberg's mod_perl compatibility patch
377 # (<20060621130708.Gcbc6e5c@leonov.stosberg.net>) has been applied
378 if test -f "$module_path/mod_perl.so" &&
379 sane_grep 'MOD_PERL' "$root/gitweb.cgi" >/dev/null
380 then
381 # favor mod_perl if available
382 cat >> "$conf" <<EOF
383 LoadModule perl_module $module_path/mod_perl.so
384 PerlPassEnv GIT_DIR
385 PerlPassEnv GIT_EXEC_PATH
386 PerlPassEnv GITWEB_CONFIG
387 <Location /gitweb.cgi>
388 SetHandler perl-script
389 PerlResponseHandler ModPerl::Registry
390 PerlOptions +ParseHeaders
391 Options +ExecCGI
392 </Location>
394 else
395 # plain-old CGI
396 resolve_full_httpd
397 list_mods=$(echo "$full_httpd" | sed 's/-f$/-l/')
398 $list_mods | sane_grep 'mod_cgi\.c' >/dev/null 2>&1 || \
399 if test -f "$module_path/mod_cgi.so"
400 then
401 echo "LoadModule cgi_module $module_path/mod_cgi.so" >> "$conf"
402 else
403 $list_mods | grep 'mod_cgid\.c' >/dev/null 2>&1 || \
404 if test -f "$module_path/mod_cgid.so"
405 then
406 echo "LoadModule cgid_module $module_path/mod_cgid.so" \
407 >> "$conf"
408 else
409 echo "You have no CGI support!"
410 exit 2
412 echo "ScriptSock logs/gitweb.sock" >> "$conf"
414 cat >> "$conf" <<EOF
415 PassEnv GIT_DIR
416 PassEnv GIT_EXEC_PATH
417 PassEnv GITWEB_CONFIG
418 AddHandler cgi-script .cgi
419 <Location /gitweb.cgi>
420 Options +ExecCGI
421 </Location>
426 mongoose_conf() {
427 cat > "$conf" <<EOF
428 # Mongoose web server configuration file.
429 # Lines starting with '#' and empty lines are ignored.
430 # For detailed description of every option, visit
431 # http://code.google.com/p/mongoose/wiki/MongooseManual
433 root $root
434 ports $port
435 index_files gitweb.cgi
436 #ssl_cert $fqgitdir/gitweb/ssl_cert.pem
437 error_log $fqgitdir/gitweb/$httpd_only/error.log
438 access_log $fqgitdir/gitweb/$httpd_only/access.log
440 #cgi setup
441 cgi_env PATH=$PATH,GIT_DIR=$GIT_DIR,GIT_EXEC_PATH=$GIT_EXEC_PATH,GITWEB_CONFIG=$GITWEB_CONFIG
442 cgi_interp $PERL
443 cgi_ext cgi,pl
445 # mimetype mapping
446 mime_types .gz=application/x-gzip,.tar.gz=application/x-tgz,.tgz=application/x-tgz,.tar=application/x-tar,.zip=application/zip,.gif=image/gif,.jpg=image/jpeg,.jpeg=image/jpeg,.png=image/png,.css=text/css,.html=text/html,.htm=text/html,.js=text/javascript,.c=text/plain,.cpp=text/plain,.log=text/plain,.conf=text/plain,.text=text/plain,.txt=text/plain,.dtd=text/xml,.bz2=application/x-bzip,.tbz=application/x-bzip-compressed-tar,.tar.bz2=application/x-bzip-compressed-tar
450 plackup_conf () {
451 # generate a standalone 'plackup' server script in $fqgitdir/gitweb
452 # with embedded configuration; it does not use "$conf" file
453 cat > "$fqgitdir/gitweb/gitweb.psgi" <<EOF
454 #!$PERL
456 # gitweb - simple web interface to track changes in git repositories
457 # PSGI wrapper and server starter (see http://plackperl.org)
459 use strict;
461 use IO::Handle;
462 use Plack::MIME;
463 use Plack::Builder;
464 use Plack::App::WrapCGI;
465 use CGI::Emulate::PSGI 0.07; # minimum version required to work with gitweb
467 # mimetype mapping (from lighttpd_conf)
468 Plack::MIME->add_type(
469 ".pdf" => "application/pdf",
470 ".sig" => "application/pgp-signature",
471 ".spl" => "application/futuresplash",
472 ".class" => "application/octet-stream",
473 ".ps" => "application/postscript",
474 ".torrent" => "application/x-bittorrent",
475 ".dvi" => "application/x-dvi",
476 ".gz" => "application/x-gzip",
477 ".pac" => "application/x-ns-proxy-autoconfig",
478 ".swf" => "application/x-shockwave-flash",
479 ".tar.gz" => "application/x-tgz",
480 ".tgz" => "application/x-tgz",
481 ".tar" => "application/x-tar",
482 ".zip" => "application/zip",
483 ".mp3" => "audio/mpeg",
484 ".m3u" => "audio/x-mpegurl",
485 ".wma" => "audio/x-ms-wma",
486 ".wax" => "audio/x-ms-wax",
487 ".ogg" => "application/ogg",
488 ".wav" => "audio/x-wav",
489 ".gif" => "image/gif",
490 ".jpg" => "image/jpeg",
491 ".jpeg" => "image/jpeg",
492 ".png" => "image/png",
493 ".xbm" => "image/x-xbitmap",
494 ".xpm" => "image/x-xpixmap",
495 ".xwd" => "image/x-xwindowdump",
496 ".css" => "text/css",
497 ".html" => "text/html",
498 ".htm" => "text/html",
499 ".js" => "text/javascript",
500 ".asc" => "text/plain",
501 ".c" => "text/plain",
502 ".cpp" => "text/plain",
503 ".log" => "text/plain",
504 ".conf" => "text/plain",
505 ".text" => "text/plain",
506 ".txt" => "text/plain",
507 ".dtd" => "text/xml",
508 ".xml" => "text/xml",
509 ".mpeg" => "video/mpeg",
510 ".mpg" => "video/mpeg",
511 ".mov" => "video/quicktime",
512 ".qt" => "video/quicktime",
513 ".avi" => "video/x-msvideo",
514 ".asf" => "video/x-ms-asf",
515 ".asx" => "video/x-ms-asf",
516 ".wmv" => "video/x-ms-wmv",
517 ".bz2" => "application/x-bzip",
518 ".tbz" => "application/x-bzip-compressed-tar",
519 ".tar.bz2" => "application/x-bzip-compressed-tar",
520 "" => "text/plain"
523 my \$app = builder {
524 # to be able to override \$SIG{__WARN__} to log build time warnings
525 use CGI::Carp; # it sets \$SIG{__WARN__} itself
527 my \$logdir = "$fqgitdir/gitweb/$httpd_only";
528 open my \$access_log_fh, '>>', "\$logdir/access.log"
529 or die "Couldn't open access log '\$logdir/access.log': \$!";
530 open my \$error_log_fh, '>>', "\$logdir/error.log"
531 or die "Couldn't open error log '\$logdir/error.log': \$!";
533 \$access_log_fh->autoflush(1);
534 \$error_log_fh->autoflush(1);
536 # redirect build time warnings to error.log
537 \$SIG{'__WARN__'} = sub {
538 my \$msg = shift;
539 # timestamp warning like in CGI::Carp::warn
540 my \$stamp = CGI::Carp::stamp();
541 \$msg =~ s/^/\$stamp/gm;
542 print \$error_log_fh \$msg;
545 # write errors to error.log, access to access.log
546 enable 'AccessLog',
547 format => "combined",
548 logger => sub { print \$access_log_fh @_; };
549 enable sub {
550 my \$app = shift;
551 sub {
552 my \$env = shift;
553 \$env->{'psgi.errors'} = \$error_log_fh;
554 \$app->(\$env);
557 # gitweb currently doesn't work with $SIG{CHLD} set to 'IGNORE',
558 # because it uses 'close $fd or die...' on piped filehandle $fh
559 # (which causes the parent process to wait for child to finish).
560 enable_if { \$SIG{'CHLD'} eq 'IGNORE' } sub {
561 my \$app = shift;
562 sub {
563 my \$env = shift;
564 local \$SIG{'CHLD'} = 'DEFAULT';
565 local \$SIG{'CLD'} = 'DEFAULT';
566 \$app->(\$env);
569 # serve static files, i.e. stylesheet, images, script
570 enable 'Static',
571 path => sub { m!\.(js|css|png)\$! && s!^/gitweb/!! },
572 root => "$root/",
573 encoding => 'utf-8'; # encoding for 'text/plain' files
574 # convert CGI application to PSGI app
575 Plack::App::WrapCGI->new(script => "$root/gitweb.cgi")->to_app;
578 # make it runnable as standalone app,
579 # like it would be run via 'plackup' utility
580 if (caller) {
581 return \$app;
582 } else {
583 require Plack::Runner;
585 my \$runner = Plack::Runner->new();
586 \$runner->parse_options(qw(--env deployment --port $port),
587 "$local" ? qw(--host 127.0.0.1) : ());
588 \$runner->run(\$app);
590 __END__
593 chmod a+x "$fqgitdir/gitweb/gitweb.psgi"
594 # configuration is embedded in server script file, gitweb.psgi
595 rm -f "$conf"
598 gitweb_conf() {
599 cat > "$fqgitdir/gitweb/gitweb_config.perl" <<EOF
600 #!@@PERL@@
601 our \$projectroot = "$(dirname "$fqgitdir")";
602 our \$git_temp = "$fqgitdir/gitweb/tmp";
603 our \$projects_list = \$projectroot;
605 \$feature{'remote_heads'}{'default'} = [1];
609 configure_httpd() {
610 case "$httpd" in
611 *lighttpd*)
612 lighttpd_conf
614 *apache2*|*httpd*)
615 apache2_conf
617 webrick)
618 webrick_conf
620 *mongoose*)
621 mongoose_conf
623 *plackup*)
624 plackup_conf
627 echo "Unknown httpd specified: $httpd"
628 exit 1
630 esac
633 case "$action" in
634 stop)
635 stop_httpd
636 exit 0
638 start)
639 start_httpd
640 exit 0
642 restart)
643 stop_httpd
644 start_httpd
645 exit 0
647 esac
649 gitweb_conf
651 resolve_full_httpd
652 mkdir -p "$fqgitdir/gitweb/$httpd_only"
653 conf="$fqgitdir/gitweb/$httpd_only.conf"
655 configure_httpd
657 start_httpd
658 url=http://127.0.0.1:$port
660 if test -n "$browser"; then
661 httpd_is_ready && git web--browse -b "$browser" $url || echo $url
662 else
663 httpd_is_ready && git web--browse -c "instaweb.browser" $url || echo $url